
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Organization_invitationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const organization_invitations = await db.organization_invitations.create(
            {
                id: data.id || undefined,
        
        invite_email: data.invite_email
        ||
        null
            ,
            
        invite_role: data.invite_role
        ||
        null
            ,
            
        invite_token: data.invite_token
        ||
        null
            ,
            
        expires_at: data.expires_at
        ||
        null
            ,
            
        accepted_at: data.accepted_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await organization_invitations.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        

        return organization_invitations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const organization_invitationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                invite_email: item.invite_email
            ||
            null
            ,
            
                invite_role: item.invite_role
            ||
            null
            ,
            
                invite_token: item.invite_token
            ||
            null
            ,
            
                expires_at: item.expires_at
            ||
            null
            ,
            
                accepted_at: item.accepted_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const organization_invitations = await db.organization_invitations.bulkCreate(organization_invitationsData, { transaction });

        // For each item created, replace relation files
        

        return organization_invitations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const organization_invitations = await db.organization_invitations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.invite_email !== undefined) updatePayload.invite_email = data.invite_email;
        
        
        if (data.invite_role !== undefined) updatePayload.invite_role = data.invite_role;
        
        
        if (data.invite_token !== undefined) updatePayload.invite_token = data.invite_token;
        
        
        if (data.expires_at !== undefined) updatePayload.expires_at = data.expires_at;
        
        
        if (data.accepted_at !== undefined) updatePayload.accepted_at = data.accepted_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await organization_invitations.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await organization_invitations.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        

        return organization_invitations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const organization_invitations = await db.organization_invitations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of organization_invitations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of organization_invitations) {
                await record.destroy({transaction});
            }
        });


        return organization_invitations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const organization_invitations = await db.organization_invitations.findByPk(id, options);

        await organization_invitations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await organization_invitations.destroy({
            transaction
        });

        return organization_invitations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const organization_invitations = await db.organization_invitations.findOne(
            { where },
            { transaction },
        );

        if (!organization_invitations) {
            return organization_invitations;
        }

        const output = organization_invitations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await organization_invitations.getOrganization({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.invite_email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'organization_invitations',
                        'invite_email',
                        filter.invite_email,
                    ),
                };
            }
            
            if (filter.invite_token) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'organization_invitations',
                        'invite_token',
                        filter.invite_token,
                    ),
                };
            }
            

            
            

            
            if (filter.expires_atRange) {
                const [start, end] = filter.expires_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.accepted_atRange) {
                const [start, end] = filter.accepted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    accepted_at: {
                    ...where.accepted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    accepted_at: {
                    ...where.accepted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.invite_role) {
                where = {
                    ...where,
                invite_role: filter.invite_role,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.organization_invitations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'organization_invitations',
                        'invite_email',
                        query,
                    ),
                ],
            };
        }

        const records = await db.organization_invitations.findAll({
            attributes: [ 'id', 'invite_email' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['invite_email', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.invite_email,
        }));
    }

    
};

